;aplikace RFM01 pijma - zen erpadla + zen ventilu TUV

;procesor PIC16F505, WDT on, EC (10MHz)
;pijme zprvu ve formtu AA,AA,AA,2D,D4,Data0 a Data15,CRC,AA.
;16_byte rozliovac kd.
;Prvnch 8_byte dat je pro tyto vyslae+pijmae vdy stejn,oznauj tato zazen.
;Dalch 8_byte dat je jedinen programovanch v kadm vyslai i pijmai
;RB4(in) m intern Pull-up, kter dr RFM01(data) na H.

;jednou za cca 30hod sepne rel (120s)a proto erpadlo
;pijme-li zprvu od svho vyslae sepne rel na 120sec
       LIST P=16F505
#include       "p16f505.inc"

CMD_lo	    equ     8		;promnn
CMD_hi	    equ     9
DEL1		equ		CMD_lo
DEL2		equ		CMD_hi
RESULT		equ		CMD_lo		
SUM		    equ     CMD_lo
CNT			equ     0A
CNT_FIFO	equ		0B
MKO			equ		0C
;
;
RX_BUF		equ		0F		;pijmaci buffer 0F-1F

CNT_1		equ		30
CNT_2		equ		31
CNT_3		equ		32

hodnota_0	equ		54		;pole pevnch hodnot(shodn s vyslaem)
hodnota_1	equ		68
hodnota_2	equ		52
hodnota_3	equ		59
hodnota_4	equ		56
hodnota_5	equ		87
hodnota_6	equ		52
hodnota_7	equ		07	

#define		VENTIL_clos	PORTB,0	;out
#define		VENTIL_open	PORTB,1	;out
#define		RELE	PORTB,2	;out
;Vpp		RB3		PORTB,3	;in
#define		DATA	PORTB,4	;in

#define		SDI		PORTC,0	;out
#define		nSEL	PORTC,1	;out
#define     nIRQ    PORTC,2	;in
#define		TX		PORTC,3	;out
#define		SCK		PORTC,4	;out
#define		SDO		PORTC,5	;in

;uivatelsky definovan hodnoty, pro kad pijma jin
hodnota_8	equ		19		;zde vlo individueln data pro dan pijma
hodnota_9	equ		1A
hodnota_10	equ		1B
hodnota_11	equ		1C
hodnota_12	equ		1D
hodnota_13	equ		1E
hodnota_14	equ		1F
hodnota_15	equ		23	

;checksum se vypot v programu,
;kad sprvn pijat zprva se dl kontroluje
;na "vlastn" adresu a jen tehdy dojde k peklopen MKO,
;tedy k sepnut rel

;END uivatelsky definovanch hodnot

			__CONFIG(0x0F1B)

			ORG     0
			GOTO    INIT
;-----------
MAIN 		MOVLW	0x00
			MOVWF	CMD_lo
			MOVLW	0x00
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x8A	;868BAND
			MOVWF	CMD_lo
			MOVLW	0x91
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x40
			MOVWF	CMD_lo
			MOVLW	0xA6
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x23
			MOVWF	CMD_lo
			MOVLW	0xC8
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x9B	;AFC
			MOVWF	CMD_lo
			MOVLW	0xC6
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x2A	;clock recovery,filter,DQD
			MOVWF	CMD_lo
			MOVLW	0xC4
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0xE0	;output 10MHz
			MOVWF	CMD_lo
			MOVLW	0xC2
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x80
			MOVWF	CMD_lo
			MOVLW	0xC0
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x88	;use FIFO
			MOVWF	CMD_lo
			MOVLW	0xCE
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x8B
			MOVWF	CMD_lo
			MOVLW	0xCE
			MOVWF	CMD_hi
			CALL	WriteCMD

			MOVLW	0x81	;open RX
			MOVWF	CMD_lo
			MOVLW	0xC0
			MOVWF	CMD_hi
			CALL	WriteCMD
;-----------
RX			MOVLW	0x11	;nati 17 byte
			MOVWF	CNT

RX_1		CLRWDT
			BTFSS	nIRQ	;ek na pjem
			GOTO	CTI_RX1
			MOVF	TMR0,W	;test TMR=0
			BTFSS	STATUS,Z
			GOTO	RX_1
;-----------
HODINY		INCF	TMR0,F		;inkrementuje hodiny
			BSF		FSR,5		;bank 1
			INCF	CNT_1,F
			BTFSS	STATUS,Z
			GOTO	END_HOD

			INCF	CNT_2,F
			BTFSS	STATUS,Z
			GOTO	END_HOD

			INCF	CNT_3,F
			BCF		CNT_3,6
			MOVF	CNT_3,w
			BTFSS	STATUS,Z
			GOTO	END_HOD
			BCF		FSR,5		;bank 0
			GOTO	SEPNI		;nepijde-li zprva od svho
								;vyslae jednou za cca30hod
								;sepne rel na 120s
END_HOD		BCF		FSR,5		;bank 0
			GOTO	RX_1
;-----------
CTI_RX1		MOVLW	RX_BUF	;pointer na schovu RX dat
			MOVWF	FSR
CTI_RX		BTFSC	nIRQ	;ek na pjem
			GOTO	CTI_RX
			CALL	RF01_RDFIFO
			MOVFW	RESULT
			MOVWF	INDF
			INCF	FSR,F
			DECFSZ	CNT,F
			GOTO	CTI_RX
		
			MOVLW	0x88	;vyma FIFO
			MOVWF	CMD_lo
			MOVLW	0xCE
			MOVWF	CMD_hi
			CALL	WriteCMD
			MOVLW	0x8B
			MOVWF	CMD_lo
			MOVLW	0xCE
			MOVWF	CMD_hi
			CALL	WriteCMD

			CLRF	SUM		;Checksum
			MOVLW	RX_BUF
			MOVWF	FSR
			MOVLW	0x10	;nati 16 byte
			MOVWF	CNT
CTI_SUMU	MOVFW	INDF
			ADDWF	SUM,F
			INCF	FSR,F
			DECFSZ	CNT,F
			GOTO	CTI_SUMU
			
			MOVFW	INDF	;porovnej pijatou sum
			XORWF	SUM,W
			BTFSS	STATUS,Z
			GOTO	ERR		;chybn pjem
			CALL	ADRESA
			XORLW	1		;pi vlastn adrese del pauza
			BTFSC	STATUS,Z
			GOTO	RX		;bad adress
;-----------
OPEN		BSF		VENTIL_open	;OK	adress
			MOVLW	0xF		;15 sekund pro oteven ventilu
			MOVWF	MKO
LOOP_open	CALL	Delay
			CALL	Delay
			CALL	Delay
			MOVLW	0x2C
			CALL	Delay_1
			DECFSZ	MKO,f
			GOTO	LOOP_open
			BCF		VENTIL_open
SEPNI		BSF		RELE	
			MOVLW	0x78	;sekundy pro sepnut rel
			MOVWF	MKO	
LOOP		CALL	Delay
			CALL	Delay
			CALL	Delay
			MOVLW	0x2C
			CALL	Delay_1
			DECFSZ	MKO,f
			GOTO	LOOP
			BCF		RELE
CLOSE		BSF		VENTIL_clos
			MOVLW	0xF		;15 sekund pro zaven ventilu
			MOVWF	MKO
LOOP_close	CALL	Delay
			CALL	Delay
			CALL	Delay
			MOVLW	0x2C
			CALL	Delay_1
			DECFSZ	MKO,f
			GOTO	LOOP_close
			BCF		VENTIL_clos
			GOTO	$-1		;ek na reset od WDT
;-----------
ERR			BSF		TX
			CALL	Delay	;0,3s vstup TX= H
			BCF		TX
			GOTO	RX
;-----------
RF01_RDFIFO	BCF		SCK
			BCF		SDI
			BCF		nSEL
			MOVLW	0x10		;16x (status)
			MOVWF	CNT_FIFO
LOP_1		BSF		SCK
			NOP
			BCF		SCK
			DECFSZ	CNT_FIFO,F
			GOTO	LOP_1

			MOVLW	0x08		;8x (data)
			MOVWF	CNT_FIFO
			CLRF	RESULT
			BCF		STATUS,C
LOP_2		RLF		RESULT,F
			BTFSC	SDO
			BSF		RESULT,0
			BSF		SCK
			NOP
			BCF		SCK
			DECFSZ	CNT_FIFO,F
			GOTO	LOP_2
			
			BSF		nSEL
			RETLW	0
;-----------
WriteCMD	MOVLW   10
			MOVWF   CNT
			BCF		SCK
			BCF		nSEL
			GOTO	LOOP_1
LOOP_2		BTFSS	CMD_hi,7
			GOTO	WR_0
WR_1		BSF		SDI
			BCF		SCK
			NOP
			BSF		SCK
			NOP
			GOTO	LOOP_3
WR_0		BCF		SDI
			BCF		SCK
			NOP
			BSF		SCK
			NOP
LOOP_3		RLF		CMD_lo,F
			RLF		CMD_hi,F
LOOP_1		DECF	CNT,F
			INCFSZ	CNT,W
			GOTO	LOOP_2
			BCF		SCK
			BSF		nSEL
			RETLW	0
;-----------
Delay		MOVLW	0xFF
Delay_1		MOVWF	DEL2
D0			CALL	DELAY1
			DECF	DEL2,F
			INCFSZ	DEL2,W
			GOTO	D0
			RETLW	0
;-----------
DELAY1		CLRF	DEL1
D1			CLRWDT
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			DECFSZ	DEL1,F
			GOTO	D1
			RETLW	0
;-----------
ADRESA		MOVLW	RX_BUF		;zde test vlastn adresy pijmae
			MOVWF	FSR			;pi shod peklop MKO (rel)

			MOVLW	hodnota_0	;test Byte_0
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1			;bad (neplatn adresa)
			INCF	FSR,F
			
			MOVLW	hodnota_1	;test Byte_1
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_2	;test Byte_2
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_3	;test Byte_3
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_4	;test Byte_4
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_5	;test Byte_5
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_6	;test Byte_6
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_7	;test Byte_7
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F
	
			MOVLW	hodnota_8	;test Byte_8
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_9	;test Byte_9
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_10	;test Byte_10
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_11	;test Byte_11
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_12	;test Byte_12
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_13	;test Byte_13
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_14	;test Byte_14
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			INCF	FSR,F

			MOVLW	hodnota_15	;test Byte_15
			XORWF	INDF,W
			BTFSS	STATUS,Z
			RETLW	1
			RETLW	0			;adresa OK
;-----------
INIT    
		MOVLW   B'11111000' 	;RB0,1,2(rel)=0
		MOVWF   PORTB
		MOVLW   B'11100111' 	;RC3(TX)=0,RC4(SCK)=0
		MOVWF  	PORTC
		MOVLW   B'10010111'     ;RB Pull-up,TOCS=0,PSA=0 presc.1:256 to TMR
		OPTION
	
		MOVLW   B'11111000'		;RB0,1,2(out)
		TRIS	6
		MOVLW   B'11100100'     ;RC0,1,3,4(out)
		TRIS	7
	
		;init RAM=0
		CLRWDT
		CLRF	TMR0
		BSF		FSR,5		;bank 1
		CLRF	CNT_1
		CLRF	CNT_2
		CLRF	CNT_3
		CLRF	FSR			;bank 0

		BSF		TX			;kontrola chodu
		CALL	Delay		;300ms set TX(RC3)
		BCF		TX

		GOTO    MAIN
;-----------
		END
